// motor_com.cpp : DLL AvP[VpɃGNX|[g֐`܂B
//

#include "stdafx.h"
#include "motor_com.h"
#include <Shlobj.h>  //[1]

#include "devicemanager.h"
#define __IID_DEFINED__
#include "devicemanager_i.h"


/* \̂̌^` */


/* COMIuWFNgpO[oϐ */
IDevice*	gpDevice;
IKernel*	gpKernel;


/* ֐̃vg^Cv錾 */
void InitMotorReg(void);
void SetMotor1_REG(double motor1_pos, double motor1_speed);
void SetMotor2_REG(double motor2_pos, double motor2_speed);
void SetMotorIntStatus(void);
int GetMotorIntStatus(void);
byte* MotorObject(void);

/*ScilabL֐*/
void MotorHandleInit(double *ret)
{	
	HRESULT hres;

    hres = ::CoInitialize(NULL); 
    if(hres != S_OK) return; 
    
	/* foCX̊ݗp */
	hres = ::CoCreateInstance(CLSID_Device, NULL, CLSCTX_ALL, 
                              IID_IDevice, (LPVOID*)&gpDevice);
	if(hres != S_OK){
		return;
	}
	
	/* p̎QƗp */
    hres = ::CoCreateInstance(CLSID_Kernel, NULL, CLSCTX_ALL,   //[6] 
                              IID_IKernel, (LPVOID*)&gpKernel);  
	if(hres != S_OK){
		return;
	}
	else{
		/* [^[pϐ̈̏ */
		byte* motor_object = MotorObject();
		InitMotorReg();
		hres = gpKernel->Write(MOTOR_REG_BASE, MOTOR_REG_SIZE, motor_object);
	}
	*ret = 1;
}

void MotorHandleClose(double *ret)
{
	gpDevice->Release();
	gpKernel->Release();
	
	::CoUninitialize();  
	
	*ret = 1;
}


void MotorInt(double *ret)
{
	HRESULT hres;
	byte* motor_object = MotorObject();
	byte* lat_mesurement_adr = motor_object + MOTOR_MEASUREADR;
	byte* lat_int_adr = motor_object;
	int *pint_status = NULL;

	/* Debug ScicosZbg*/
//	SetMotorIntStatus();
	pint_status = (int*)&motor_object[MOTOR_PWMADR];
	
	/*݃fobOu[Np(0:gp)@TOPPERS*/
	*pint_status = DEBUG_SCICOS;

	/* ݑOɃf[^ނ̊m([^[v֘Af[^̂) */
//	hres = gpKernel->Write( (MOTOR_REG_BASE+MOTOR_MEASUREADR), MOTOR_REG_MEASURE_SIZE, lat_mesurement_adr);
	hres = gpKernel->Write( (MOTOR_REG_BASE), MOTOR_REG_SIZE, motor_object);
	if(hres == S_OK){
		hres = gpDevice->RaiseInterrupt(0);

		if(hres == S_OK){
//			byte* lat_PWM_adr = motor_object;
//			while(1){
//				/* L̈悩PWM֘Â݂ǂݍ */
//				hres = gpKernel->Read( (MOTOR_REG_BASE), MOTOR_REG_PWM_SIZE, lat_PWM_adr);
//				if(hres == S_OK){
//					pint_status = (int*)&lat_PWM_adr[MOTOR_PWMADR];
//					if((*pint_status) == 0){
//						*ret = 1;
//						break;
//					}
//				}
//				else{
//					*ret = 0;
//					break;
//				}
//			}
		}
		else{
			*ret = 0;
		}
	}
	else{
		*ret = 0;
	} 

}

void SetMotorIntStatus(void)
{
	byte* pmotor_object		= MotorObject();
	int* pMotorIntStatus	= (int*)pmotor_object[MOTOR_INT_ENABLE];

	*pMotorIntStatus = 1;

}
int GetMotorIntStatus(void)
{
	byte* pmotor_object		= MotorObject();
	int* pMotorIntStatus	= (int*)pmotor_object[MOTOR_INT_ENABLE];

	return(*pMotorIntStatus);
}
/* ResetIntStatusToppersݒ肵܂ */


void SetMotor1_Data(double *motor1_pos, double *motor1_speed, double *ret)
{
	SetMotor1_REG( *motor1_pos, *motor1_speed);
	*ret = 1;
}

void GetPWMData(double *ret)
{
	HRESULT hres;
	byte* motor_object = MotorObject();	
	byte* lat_PWM_adr = motor_object;

	/* L̈悩PWM֘Â݂ǂݍ */
	while(1){
		int* pint_fin = NULL;

		hres = gpKernel->Read( (MOTOR_REG_BASE), MOTOR_REG_PWM_SIZE, lat_PWM_adr);
		if(hres == S_OK){
			/* ݊mF */
			pint_fin = (int*)&lat_PWM_adr[MOTOR_INT_ADR]; 
			if((*pint_fin) == 0){
				*ret = 1;
				break;
			}
		}
		else{
			*ret = 0;
			break;
		}
	}
}

void GetMotor1_PWMDuty(double *ret)
{
	byte* pmotor_object	= MotorObject();
	int* ppwm_duty		= (int*)&pmotor_object[MOTOR1_PWMDUTY];

	*ret				= (double)*ppwm_duty; 
}

void GetMotor1_PWMPeriod(double *ret)
{
	byte* pmotor_object	= MotorObject();
	int* ppwm_period		= (int*)&pmotor_object[MOTOR1_PWMPERIOD];

	*ret				= (double)*ppwm_period; 
}

void SetMotor2_Data(double *motor2_pos, double *motor2_speed, double *ret)
{
	SetMotor2_REG( *motor2_pos, *motor2_speed);
	*ret = 1;
}

void GetMotor2_PWMDuty(double *ret)
{
	byte* pmotor_object	= MotorObject();
	int* ppwm_duty		= (int*)&pmotor_object[MOTOR2_PWMDUTY];

	*ret				= (double)*ppwm_duty; 
}

void GetMotor2_PWMPeriod(double *ret)
{
	byte* pmotor_object	= MotorObject();
	int* ppwm_period	= (int*)&pmotor_object[MOTOR2_PWMPERIOD];

	*ret				= (double)*ppwm_period; 
}


void InitMotorReg(void)
{
	SetMotor1_REG( 0, 0);
	SetMotor2_REG( 0, 0);
}

/*---------------------------------------------------------------*/
__inline
void SetMotor1_REG(double motor1_pos, double motor1_speed)
{
	byte* pmotor_object		= MotorObject();
	int* pMotor1Position	= (int*)&pmotor_object[MOTOR1_POSITION];
	int* pMotor1Speed		= (int*)&pmotor_object[MOTOR1_SPEED];
	
	*pMotor1Position		= (int)motor1_pos;
	*pMotor1Speed			= (int)motor1_speed;
}

__inline
void SetMotor2_REG(double motor2_pos, double motor2_speed)
{
	byte* pmotor_object		= MotorObject();
	int* pMotor2Position	= (int*)&pmotor_object[MOTOR2_POSITION];
	int* pMotor2Speed		= (int*)&pmotor_object[MOTOR2_SPEED];
	
	*pMotor2Position		= (int)motor2_pos;
	*pMotor2Speed			= (int)motor2_speed;
}


/* foCXނ̎ */
__inline
byte* MotorObject(void)
{
	static byte sMotor_Reg_Data[MOTOR_REG_SIZE];
	return sMotor_Reg_Data;
}


