/* motor1.c */
/* MOTOR^XN͒/x̒Pʂ[cm][cm/s]Ő䂵܂ */
/* Scilab[m][m/s]Ő䂵܂(toppers֓͂̍ۂ[m]->[cm]ϊ܂)*/

#include <kernel.h>
#include <t_syslog.h>
#include <t_stdlib.h>
#include "kernel_cfg.h"
#include "itron.h"
#include "syssvc/serial.h"
#include "syssvc/syslog.h"
#include "rtos_api.h"
#include "motor1.h"


/*----^XNŗLϐ`---*/
static long_t gMotor1_Position;
static long_t gMotor1_TargetPosition;
static long_t gMotor1_TargetSpeed;
static long_t gMotor1_Direction;

/* PID֘A */
static long_t gdelta_speed_Sum;
static long_t gPredelta_speed;
static long_t gdelta_position_Sum;
static long_t gPredelta_position;

/*HALwAhX`*/

/* COMIuWFNgp AhX`(SkyEye̒`ƍ킹) */
/* [^[1p AhXItZbg */
#define MOTOR_INT_ENABLE	(0)		/* int */
#define MOTOR1_SPEED		(0x80001014)	/* int */		
#define MOTOR1_POSITION		(0x80001018)	/* int */
#define MOTOR1_PWMDUTY		(0x80001004)	/* int */
#define MOTOR1_PWMPERIOD	(0x80001008)	/* int */
#define MOTOR1_INT_ENABLE	(0x80001024)	/* int */

/*------------֐̒`----------*/
/*^XNw*/
void init_MOTOR1(void);
void start_MOTOR1(long_t Speed, long_t Length, long_t Event);

/*ݑw*/
void Int_PIDControl4MOTOR1(void);
void SetMotor1IntEnable(void);
void ResetMotor1IntEnable(void);
bool_t GetMotor1IntEnable(void);
bool_t* Motor1IntEnable(void);

/*CxgtOZbgp*/
void (*evtflgfunc1)(void);
void reset_motor1_event(void);

/*^XNNp*/
void (*wakeupfunc1)(void);
void reset_motor1_sleep(void);
void nullfunc1(void);

/*HALw*/
long_t HAL_GetMotor1Speed(void);
long_t HAL_GetMotor1Position(void);
void HAL_SetMotor1Speed(long_t speed);
void HAL_SetMotor1Position(long_t position);
void HAL_SetMotor1PWMDuty(long_t Duty);
void HAL_SetMotor1PWMPeriod(long_t Period);

/*----------MotorAPIw-------------*/

void Motor1_Init(void)
{
	MOTOR1_RQST_MSG_ST *pSndMsg;
	ER ercd;

	(void)tprs_getmemoryblock((ID)POOL_MOTOR1, (VP *)&pSndMsg);
	pSndMsg->func_code				=  MOTOR1_INIT;
	/*Wait*/
	ercd = tprs_sendmail((ID)MB_MOTOR1, (T_MSG *)pSndMsg);
	if (ercd == E_OK) {
	}
	else {				
		/*	bZ[WMoȂꍇ擾	*/
		(void)tprs_releasememoryblock((ID)POOL_MOTOR1, (VP)pSndMsg);
	} 
}

void Motor1_DRV(long_t Speed, long_t Length)
{
	MOTOR1_RQST_MSG_ST *pSndMsg;
	ER ercd;

	(void)tprs_getmemoryblock((ID)POOL_MOTOR1, (VP *)&pSndMsg);
	pSndMsg->func_code				=  MOTOR1_DRV;
	pSndMsg->Speed					=  Speed;
	pSndMsg->Length					=  Length;
	/*Wait*/
	ercd = tprs_sendmail((ID)MB_MOTOR1, (T_MSG *)pSndMsg);
	if (ercd == E_OK) {
		ercd = tprs_receivemail( (ID)MB_MOTOR1_RCV, (T_MSG **)&pSndMsg);
		if(ercd == E_OK){
			if(pSndMsg->result == TRUE){
				syslog(LOG_INFO, "Motor1_DRV_Req_OK");
			}
			else{
				syslog(LOG_INFO, "Motor1_DRV_Req_NG");	
			}
		}
		else{
			syslog(LOG_INFO, "> tprs_receivemail_MOTOR2_RCV_NG");	
		}
		
		(void)tprs_releasememoryblock((ID)POOL_MOTOR1, (VP)pSndMsg);
	}
	else {				
		/*	bZ[WMoȂꍇ擾	*/
		(void)tprs_releasememoryblock((ID)POOL_MOTOR1, (VP)pSndMsg);
	} 
}


void Motor1_DRVEvent(long_t Speed, long_t Length)
{
	MOTOR1_RQST_MSG_ST *pSndMsg;
	ER ercd;

	(void)tprs_getmemoryblock((ID)POOL_MOTOR1, (VP *)&pSndMsg);
	pSndMsg->func_code				=  MOTOR1_DRV_EVENT;
	pSndMsg->Speed					=  Speed;
	pSndMsg->Length					=  Length;
	/*Wait*/
	ercd = tprs_sendmail((ID)MB_MOTOR1, (T_MSG *)pSndMsg);
	if (ercd == E_OK) {
		ercd = tprs_receivemail( (ID)MB_MOTOR1_RCV, (T_MSG **)&pSndMsg);
		if(ercd == E_OK){
			if(pSndMsg->result == TRUE){
				syslog(LOG_INFO, "Motor1_DRV_Req_OK");
			}
			else{
				syslog(LOG_INFO, "Motor1_DRV_Req_NG");	
			}
		}
		else{
			syslog(LOG_INFO, "> tprs_receivemail_MOTOR2_RCV_NG");	
		}
		
		(void)tprs_releasememoryblock((ID)POOL_MOTOR1, (VP)pSndMsg);
	}
	else {				
		/*	bZ[WMoȂꍇ擾	*/
		(void)tprs_releasememoryblock((ID)POOL_MOTOR1, (VP)pSndMsg);
	} 
}


void Motor1_Stop(void)
{
	MOTOR1_RQST_MSG_ST *pSndMsg;
	ER ercd;

	(void)tprs_getmemoryblock((ID)POOL_MOTOR1, (VP *)&pSndMsg);
	pSndMsg->func_code				=  MOTOR1_STOP;
	/*Wait*/
	ercd = tprs_sendmail((ID)MB_MOTOR1, (T_MSG *)pSndMsg);
	if (ercd == E_OK) {
	}
	else {				
		/*	bZ[WMoȂꍇ擾	*/
		(void)tprs_releasememoryblock((ID)POOL_MOTOR1, (VP)pSndMsg);
	} 
}

void Motor1_Wait_DRVStop(void)
{
	FLGPTN waitflag;
	tprs_waiteventflag( EV_MOTOR1, event_MOTOR1DRV, TWF_ANDW, &waitflag );

}

/* VN쓮p */
void Motor1_Wait_EventStop(void)
{
	FLGPTN waitflag;
	tprs_waiteventflag( EV_MOTOR1, event_MOTOR1DRV_PRESTART, TWF_ANDW, &waitflag );

}


/*--------taskMain-------------*/
void Motor1(intptr_t exinf)
{
	ER ercd;
	MOTOR1_RQST_MSG_ST *pMsg;
	
	init_MOTOR1();

	while (1) {
		ercd = tprs_receivemail( (ID)MB_MOTOR1, (T_MSG **)&pMsg);
		if (ercd == E_OK) {
			switch (pMsg->func_code) {
			
			case MOTOR1_INIT:
				init_MOTOR1();
				(void)tprs_releasememoryblock((ID)POOL_MOTOR1, (VP)pMsg);
				break;

			case MOTOR1_DRV:
				start_MOTOR1(pMsg->Speed, pMsg->Length, MOTOR1_NO_EVENT);
				pMsg->result = TRUE;
				ercd = tprs_sendmail((ID)MB_MOTOR1_RCV, (T_MSG *)pMsg);
				break;

			case MOTOR1_DRV_EVENT:
				start_MOTOR1(pMsg->Speed, pMsg->Length, MOTOR1_PRESTART);
				pMsg->result = TRUE;
				ercd = tprs_sendmail((ID)MB_MOTOR1_RCV, (T_MSG *)pMsg);
				break;
				
			case MOTOR1_STOP:
				ResetMotor1IntEnable();
				(void)tprs_releasememoryblock((ID)POOL_MOTOR1, (VP)pMsg);
			default:			
				break;								
			}
		}
	}	/*while*/
}


/*--------------^XNAPIw------------*/
void init_MOTOR1(void)
{
	gMotor1_Position = 0;
	gMotor1_TargetPosition = 0;
	gMotor1_TargetSpeed = MOTOR1_SPEEDLOW;
	gMotor1_Direction = 1;
	gdelta_speed_Sum = 0;
	gPredelta_speed = 0;
	gdelta_position_Sum = 0;
	gPredelta_position = 0;

	wakeupfunc1 = nullfunc1;
	evtflgfunc1 = nullfunc1;
	
	tprs_seteventflag( EV_MOTOR1, event_MOTOR1DRV );
	tprs_seteventflag( EV_MOTOR1, event_MOTOR1DRV_PRESTART );
	
	ResetMotor1IntEnable();
	HAL_SetMotor1PWMDuty(0);
	HAL_SetMotor1PWMPeriod( PID1_MAX);
	HAL_SetMotor1Speed(0);
	HAL_SetMotor1Position(0);
	syslog(LOG_NOTICE, "MOTOR1_InitFin");
}


void start_MOTOR1(long_t Speed, long_t Length, long_t Event)
{
//	static long_t sTimeOut;
//	long_t intenable;

	ResetMotor1IntEnable();
	/*ڕWxݒ*/
	gMotor1_TargetSpeed = Speed;
	/*싗̕ϊ*/
	gMotor1_TargetPosition = gMotor1_Position + Length;
	/*PID֘Ȁ*/
	gdelta_speed_Sum = 0;
	gPredelta_speed = 0;
	gdelta_position_Sum = 0;
	gPredelta_position = 0;
	/*̐ݒ*/
	if(Length < 0){
		gMotor1_Direction = 0;
	}
	else{
		gMotor1_Direction = 1;
	}

	/*Jn*/
	if(Event == MOTOR1_PRESTART){
		evtflgfunc1 = reset_motor1_event;

	}
	else{
		evtflgfunc1 = nullfunc1;
	}
	
	tprs_cleareventflag( EV_MOTOR1 , ~event_MOTOR1DRV );
	tprs_cleareventflag( EV_MOTOR1 , ~event_MOTOR1DRV_PRESTART );
		
	SetMotor1IntEnable();

	syslog(LOG_INFO, "Motor1_DRV_Start");
	
//	intenable = TRUE;
//	sTimeOut = 0;
//	while(intenable == TRUE){
//		tprs_delaytask(50);
//		intenable = GetMotor1IntEnable();
//		
//		if(sTimeOut > 1000){
//			syslog(LOG_NOTICE, "Motor1DRV_TimeOut");		
//			break;
//		}
//		else{
//			sTimeOut++;
//		}
//	}
//	syslog(LOG_NOTICE, "Motor1DRV_Finish");
}


void reset_motor1_event(void)
{
	tprs_intseteventflag( EV_MOTOR1, event_MOTOR1DRV_PRESTART );
	evtflgfunc1 = nullfunc1;
}

void reset_motor1_sleep(void)
{
	tprs_intwakeuptask(MOTOR1);
	wakeupfunc1 = nullfunc1;
}
void nullfunc1(void)
{

}

void SetMotor1IntEnable(void)
{
	bool_t* pint_enable_flag = Motor1IntEnable();
	*pint_enable_flag = TRUE;
}

void ResetMotor1IntEnable(void)
{
	bool_t* pint_enable_flag = Motor1IntEnable();
	*pint_enable_flag = FALSE;
}

bool_t GetMotor1IntEnable(void)
{
	bool_t* pint_enable_flag = Motor1IntEnable();
	return (*pint_enable_flag);
}

bool_t* Motor1IntEnable(void)
{
	static bool_t sMotor1IntEnbFlag = FALSE;
	return &sMotor1IntEnbFlag;
}


/*------ݐw-------------*/
void Int_Motor1(void)
{
	bool_t int_motor1_enable = GetMotor1IntEnable();
	
	if(int_motor1_enable == TRUE){
		Int_PIDControl4MOTOR1();
	}
	else{
		/* 䖳̂߉Ȃ */
		HAL_SetMotor1PWMDuty(0);
	}

}

void Int_PIDControl4MOTOR1(void)
{
	long_t speed;
	long_t position;
	long_t delta_speed;
	long_t delta_position;

	long_t Duty_P;
	long_t Duty_I;
	long_t Duty_D;
	long_t Duty_PID;

	static long_t sHoldCnt;

	speed = HAL_GetMotor1Speed();
	position = HAL_GetMotor1Position();

	/*݈ʒu̍XV*/
	gMotor1_Position = position;

	/*ʒu΍̌v*/
	if(gMotor1_Direction == 1){
		delta_position = gMotor1_TargetPosition - position;
	}
	else{
		delta_position = position - gMotor1_TargetPosition;
	}
	
	if(delta_position <= 5){
		gMotor1_TargetSpeed = MOTOR1_SPEEDLOW;
	}
	else if(delta_position <= 10){
		gMotor1_TargetSpeed = MOTOR1_SPEEDMID;
		sHoldCnt = 0;
		evtflgfunc1();	/* OJnpCxg̐ݒ */
	}
	else{
		/*ڕWx̂܂*/
	}

	if(delta_position <= 0){
		/*ʒuߐ*/
		if(sHoldCnt > 10){
			ResetMotor1IntEnable();
			tprs_intseteventflag( EV_MOTOR1, event_MOTOR1DRV );
			tprs_intseteventflag( EV_MOTOR1, event_MOTOR1DRV_PRESTART );
			sHoldCnt = 0;
			Duty_PID = 0;
		}
		else{
			/*P̌vZ*/
			Duty_P = GAIN1_P * delta_position;
			/*ǏvZ*/
			gdelta_position_Sum = gdelta_position_Sum + delta_position;
			Duty_I = GAIN1_I * gdelta_position_Sum;
			/*ĎvZ*/
			Duty_D = GAIN1_D * (delta_position - gPredelta_position);
			gPredelta_position = delta_position;

			Duty_PID = Duty_P + Duty_I + Duty_D;
		}
		sHoldCnt++;
	}
	else{
		/* x */
		/*x΍̌v*/
		delta_speed = gMotor1_TargetSpeed - speed;
	
		/*P̌vZ*/
		Duty_P = GAIN1_P * delta_speed;
		/*ǏvZ*/
		gdelta_speed_Sum = gdelta_speed_Sum + delta_speed;
		Duty_I = GAIN1_I * gdelta_speed_Sum;
		/*ĎvZ*/
		Duty_D = GAIN1_D * (delta_speed - gPredelta_speed);
		gPredelta_speed = delta_speed;

		Duty_PID = Duty_P + Duty_I + Duty_D;
	}


	/*PIDo͐*/
	if(PID1_MAX < Duty_PID){
		Duty_PID = PID1_MAX;
	}
	else if(PID1_MIN > Duty_PID){
		Duty_PID = PID1_MIN;
	}
	else{
		/*Ȃ*/
	}


	/*PWMo*/
	HAL_SetMotor1PWMDuty(Duty_PID);

}


/*---HALw̒`------*/
long_t HAL_GetMotor1Speed(void)
{
	long_t* pMotor1Speed = (long_t*)MOTOR1_SPEED;
	return (*pMotor1Speed);
}

void HAL_SetMotor1Speed(long_t speed)
{
	long_t* pMotor1Speed = (long_t*)MOTOR1_SPEED;
	*pMotor1Speed = speed;
}

long_t HAL_GetMotor1Position(void)
{
	long_t* pMotor1Position = (long_t*)MOTOR1_POSITION;
	return (*pMotor1Position);
}

void HAL_SetMotor1Position(long_t position)
{
	long_t* pMotor1Position = (long_t*)MOTOR1_POSITION;
	*pMotor1Position = position;
}

void HAL_SetMotor1PWMDuty(long_t Duty)
{
	long_t* pMotor1PWMDuty = (long_t*)MOTOR1_PWMDUTY;
	*pMotor1PWMDuty = Duty;
}

void HAL_SetMotor1PWMPeriod(long_t Period)
{
	long_t* pMotor1PWMPeriod = (long_t*)MOTOR1_PWMPERIOD;
	*pMotor1PWMPeriod = Period;
}
